'********** MAKE123.BAS
'Written 6/8/89 by Larry Hupman
'5719 Beswick Dr., San Jose, CA  95123
'Written in QuickBasic 4.0
'Program will Convert an Ascii File Into A Lotus Version 2 Worksheet.
'This is FREEWARE and as such MAY NOT BE SOLD UNDER ANY CIRCUMSTANCES.
'You are Welcome to Change program to suit your Needs.
'PLEASE: Write me, if any bugs found or any enhancements are made , so I can
'        learn from your expertise.
'"Write" Subroutines taken from "Write123.bas"
'PC Magazine * Ethan Winer * Martin Valley
'Version 1.01 - 7/15/89 Fixes
'      1. Allow for Short Strings
'      2. Do Not Allow Make123 to start with just a filename
'      3. Write First row to First row instead of Second row
'      4. Allow 100-240 character width
'      5. Allow numbers to convert to labels properly if so determined.

DEFINT A-Z
DECLARE SUB WriteColWidth (Column, ColWidth)
DECLARE SUB WriteNumber (Row, Column, ColWidth, Fmt$, number#)
DECLARE SUB WriteInteger (Row, Column, ColWidth, Integ)
DECLARE SUB WriteLabel (Row, Column, ColWidth, Msg$)
DECLARE SUB MovePlace ()

DIM SHARED ColNum(100)   'the maximum number of columns to be written
DIM SHARED Translate$(300)
DIM SHARED Filenum      'the file number to use
DIM SHARED Place
DIM SHARED Test$
DIM SHARED Nulltest$
DIM SHARED CmdLine$



'  ***** Variables *******

Quote$ = CHR$(34)
Aspace$ = " "
Start = 0
Place = 1
Filenum = 2
Linenum = 1
Start = 1
Rec = 0                 '07/15/89 #3
Row = 0                 'row numbers in Lotus begin with 0
i = 0


CLS
CmdLine$ = UCASE$(COMMAND$)
IF LEN(CmdLine$) < 1 THEN GOTO Badstartend
ON ERROR GOTO Badstart
Test$ = LEFT$(CmdLine$, 1)



WHILE Test$ <> Aspace$
    Place = Place + 1
    IF Place > LEN(CmdLine$) THEN GOTO Badstartend    '7/15/89 #2
    Filename$ = Filename$ + Test$
    IF Test$ = "." THEN File$ = LEFT$(Filename$, LEN(Filename$) - 1)
    Test$ = MID$(CmdLine$, Place, 1)
WEND
IF LEN(File$) < 1 THEN File$ = Filename$
OPEN Filename$ FOR INPUT AS 1
OPEN File$ + ".WK1" FOR BINARY AS 2
Temp = 0                'OpCode for Start of File
PUT Filenum, , Temp
Temp = 2                'the data length is 2 (for the following integer)
PUT Filenum, , Temp
Temp = 1030             'the Lotus version number
PUT Filenum, , Temp     'Note: Lotus version 1 = 1028; version 2 = 1030

CALL MovePlace
Savplace = Place



WHILE NOT EOF(1)
  LINE INPUT #1, AsciiLine$
  LOCATE 1, 1
  PRINT "MAKE123     Version 1.1     July 15, 1989     Copyright 1989     By:Larry Hupman"
  LOCATE 10, 23
  PRINT "Writing Row Number "; (Rec + 1); " of "; File$; ".WK1"
  WHILE Place <= LEN(CmdLine$)
    IF Place >= LEN(AsciiLine$) THEN                 '7/15/89 #1
       FOR Addspace = 1 TO (Place - LEN(AsciiLine$) + 1)
           AsciiLine$ = AsciiLine$ + Aspace$
       NEXT Addspace
    END IF
    IF UCASE$(Test$) = "L" THEN
           ERASE Translate$
           Finish = Start
           WHILE Test$ <> Aspace$ AND Place <= LEN(AsciiLine$) + 1     '07/15/89 #4
             CALL MovePlace
             Translate$(i%) = Translate$(i%) + Test$
           WEND
           IF LEN(RTRIM$(MID$(AsciiLine$, Linenum, VAL(Translate$(i%))))) > 0 THEN
              WriteLabel Rec, i%, VAL(Translate$(i%)), MID$(AsciiLine$, Linenum, VAL(Translate$(i%)))
           END IF
           Linenum = Linenum + VAL(Translate$(i%))
           i% = i% + 1
    END IF
    IF UCASE$(Test$) = "N" THEN
           ERASE Translate$
           Finish = Start
           WHILE Test$ <> Aspace$ AND Place <= LEN(CmdLine$)
             CALL MovePlace
             Translate$(i%) = Translate$(i%) + Test$
           WEND
          WHILE Test$ = Aspace$ AND Place < LEN(CmdLine$)
            CALL MovePlace
          WEND
          IF Test$ <> Quote$ OR Place >= LEN(CmdLine$) THEN
              i% = i% + 1
              Translate$(i%) = "G1"
          END IF
          IF Test$ = Quote$ THEN
            CALL MovePlace
            i% = i% + 1
            WHILE Test$ <> Quote$ AND Place < LEN(CmdLine$)
               Translate$(i%) = Translate$(i%) + Test$
               CALL MovePlace
            WEND
            CALL MovePlace
          END IF
          n% = i% - 1
          Nulltest$ = LTRIM$(MID$(AsciiLine$, Linenum, VAL(Translate$(n%))))
          IF LEN(Nulltest$) = 0 THEN
            Testnum = 48
          ELSE
            Testnum = ASC(Nulltest$)
          END IF
          ON ERROR GOTO Theend
          IF Testnum = 45 THEN Testnum = ASC(MID$(Nulltest$, 2, 1))
          IF Testnum > 47 AND Testnum < 58 THEN     ' Testnum Probably a Number
             WriteNumber Rec, n%, VAL(Translate$(n%)), Translate$(i%), VAL(MID$(AsciiLine$, Linenum, VAL(Translate$(n%))))
          ELSE                     ' Testnum Not a Number, so Write it as a Label
             WriteLabel Rec, n%, VAL(Translate$(n%)), MID$(AsciiLine$, Linenum, VAL(Translate$(n%)))
          END IF
          Linenum = Linenum + VAL(Translate$(n%))
          i% = n% + 1
    END IF
    Start = i%
    DO WHILE UCASE$(Test$) <> "L" AND UCASE$(Test$) <> "N" AND Place <= LEN(CmdLine$)
      CALL MovePlace
    LOOP
  WEND
  Rec = Rec + 1
  i% = 0
  Place = Savplace
  Test$ = MID$(CmdLine$, Place, 1)
  Linenum = 1
WEND

Theend:

LOCATE 14, 35
PRINT "All Done"
'Write the "End of File" record and close the file
Temp = 1                'OpCode for End of File
PUT 2, , Temp
Temp = 0                'its Data length is zero
PUT 2, , Temp

CLOSE
END

Badstart:                      ' Make123 started with No Parameters
CLS
RESUME Badstartend             ' If ON ERROR is Invoked
Badstartend:
LOCATE 1, 1
PRINT "MAKE123     Version 1.1     July 15, 1989     Copyright 1989     By:Larry Hupman"
LOCATE 7, 20
PRINT "Make123 was not used as designed."
LOCATE 11, 3
PRINT "Type the Command - Make123 - then"
LOCATE 13, 3
PRINT "Filename of file to be converted.   Either L or N (Label or Number)."
LOCATE 14, 3
PRINT "Then a number that corresponds with the width you want to have selected"
LOCATE 15, 3
PRINT "from text file you're reading from. "
LOCATE 17, 3
PRINT "N(umber) also has has an option that will set numeric format. "
LOCATE 18, 3
PRINT Quote$; "C"; Quote$; " for Currency, "; Quote$; "F"; Quote$; " for Fixed, and "; Quote$; "P"; Quote$; " for Percent."
LOCATE 19, 3
PRINT "Then add number of decimal places.  "; Quote$; "F0"; Quote$; " = Fixed Format, Zero Decimal Places."
LOCATE 22, 3
PRINT "Purely Theoretical Example: Make123 Test.txt L25 L17 L20 N10 "; Quote$; "C2"; Quote$

SUB MovePlace
    Place = Place + 1
    Test$ = MID$(CmdLine$, Place, 1)
END SUB

SUB WriteColWidth (Column, ColWidth)
       IF ColNum(Column) = 0 THEN           'if width record not already written
       IF ColWidth = 0 THEN ColWidth = 9 'default to 9 if no value
       Temp = 8
       PUT Filenum, , Temp
       Temp = 3
       PUT Filenum, , Temp
       PUT Filenum, , Column
       Temp$ = CHR$(ColWidth)
       PUT Filenum, , Temp$
       ColNum(Column) = 1                'show we did this one for later
    END IF

END SUB

SUB WriteLabel (Row, Column, ColWidth, Msg$)

    IF LEN(Msg$) > 240 THEN Msg$ = LEFT$(Msg$, 240)

    Temp = 15                   'OpCode for a label
    PUT Filenum, , Temp
    Temp = LEN(Msg$) + 7        'Length + 5-byte header + "'" + CHR$(0) byte
    PUT Filenum, , Temp
    Temp$ = CHR$(127)           '127 is default format for unprotected cell
    ' Temp$ = CHR$(255)           ' 255 is default for protected cell
    PUT Filenum, , Temp$
    PUT Filenum, , Column
    PUT Filenum, , Row
    Temp$ = "'" + Msg$ + CHR$(0) 'NOTE:  "'" means label will be left aligned

    PUT Filenum, , Temp$
    CALL WriteColWidth(Column, ColWidth)

END SUB

SUB WriteNumber (Row, Column, ColWidth, Fmt$, number#)

    IF LEFT$(Fmt$, 1) = "F" THEN                    'fixed ...
       Format$ = CHR$(0 + VAL(RIGHT$(Fmt$, 1)))     'number of decimal places
    ELSEIF LEFT$(Fmt$, 1) = "C" THEN                'currency ...
       Format$ = CHR$(32 + VAL(RIGHT$(Fmt$, 1)))    'number of decimal places
    ELSEIF LEFT$(Fmt$, 1) = "P" THEN                'percent ...
       Format$ = CHR$(48 + VAL(RIGHT$(Fmt$, 1)))    'number of decimal places
    ELSE
       Format$ = CHR$(127)                          'use default format
      '  format$ = CHR$(255)                          'optional to protect cell
    END IF

IF LEN(Nulltest$) <> 0 THEN      ' If range is Null - Don't write a zero
    Temp = 14                    ' Leave Cell Blank.
    PUT Filenum, , Temp
    Temp = 13
    PUT Filenum, , Temp
    PUT Filenum, , Format$
    PUT Filenum, , Column
    PUT Filenum, , Row
    PUT Filenum, , number#
   
    CALL WriteColWidth(Column, ColWidth)
END IF
END SUB

